Overview | Modules | Class Hierarchy | Classes | Members

# tlp::TemplateFactory< ObjectFactory, ObjectType, Context > Class Template Reference
[Plugins]

`#include <TemplateFactory.h>`

Inherits tlp::TemplateFactoryInterface.

Inheritance diagram for tlp::TemplateFactory< ObjectFactory, ObjectType, Context >:

[legend]
Collaboration diagram for tlp::TemplateFactory< ObjectFactory, ObjectType, Context >:

[legend]
List of all members.

### template<class ObjectFactory, class ObjectType, class Context>
class tlp::TemplateFactory< ObjectFactory, ObjectType, Context >

## Public Types

- typedef std::map< std::string,
  ObjectFactory * > ObjectCreator

## Public Member Functions

- TemplateFactory ()
- Iterator< std::string > * availablePlugins ()
- bool pluginExists (const std::string &pluginName)
- ObjectType * getPluginObject (const std::string &name, Context p)
- StructDef getPluginParameters (std::string name)
- std::string getPluginRelease (std::string name)
- std::list< tlp::Dependency > getPluginDependencies (std::string name)
- std::string getPluginsClassName ()
- void registerPlugin (ObjectFactory *objectFactory)
- void removePlugin (const std::string &name)

## Public Attributes

- ObjectCreator objMap
- std::map< std::string, StructDef > objParam
- std::set< std::string > objNames
- std::map< std::string, std::list<
  tlp::Dependency > > objDeps
- std::map< std::string, std::string > objRels

## Member Typedef Documentation

template<class ObjectFactory, class ObjectType, class Context>
typedef std::map< std::string , ObjectFactory * > tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::ObjectCreator

## Constructor & Destructor Documentation

template<class ObjectFactory, class ObjectType, class Context>
tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::TemplateFactory | ( |  | ) | `[inline]`

## Member Function Documentation

template<class ObjectFactory, class ObjectType, class Context>
Iterator<std::string>* tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::availablePlugins | ( |  | ) | `[virtual]`

| Implements tlp::TemplateFactoryInterface.

template<class ObjectFactory, class ObjectType, class Context>
std::list<tlp::Dependency> tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::getPluginDependencies | ( | std::string | name | ) | `[virtual]`

| Implements tlp::TemplateFactoryInterface.

template<class ObjectFactory, class ObjectType, class Context>
ObjectType* tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::getPluginObject | ( | const std::string & | name,
|  | Context | p
| ) |

template<class ObjectFactory, class ObjectType, class Context>
StructDef tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::getPluginParameters | ( | std::string | name | ) | `[virtual]`

| Implements tlp::TemplateFactoryInterface.

template<class ObjectFactory, class ObjectType, class Context>
std::string tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::getPluginRelease | ( | std::string | name | ) | `[virtual]`

| Implements tlp::TemplateFactoryInterface.

template<class ObjectFactory, class ObjectType, class Context>
std::string tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::getPluginsClassName | ( |  | ) | `[virtual]`

| Implements tlp::TemplateFactoryInterface.

template<class ObjectFactory, class ObjectType, class Context>
bool tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::pluginExists | ( | const std::string & | pluginName | ) | `[virtual]`

| Implements tlp::TemplateFactoryInterface.

template<class ObjectFactory, class ObjectType, class Context>
void tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::registerPlugin | ( | ObjectFactory * | objectFactory | ) |

template<class ObjectFactory, class ObjectType, class Context>
void tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::removePlugin | ( | const std::string & | name | ) | `[virtual]`

| Implements tlp::TemplateFactoryInterface.

## Member Data Documentation

template<class ObjectFactory, class ObjectType, class Context>
std::map<std::string, std::list<tlp::Dependency> > tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::objDeps

template<class ObjectFactory, class ObjectType, class Context>
ObjectCreator tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::objMap

template<class ObjectFactory, class ObjectType, class Context>
std::set<std::string> tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::objNames

template<class ObjectFactory, class ObjectType, class Context>
std::map<std::string,StructDef> tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::objParam

template<class ObjectFactory, class ObjectType, class Context>
std::map<std::string, std::string> tlp::TemplateFactory< ObjectFactory, ObjectType, Context >::objRels

Tulip Software by LaBRI Visualization Team 2001 - 2010